﻿using System;
using System.Collections.Generic;
using System.Text;
using AdiIRCAPI;
using System.Diagnostics;

namespace Rhythmbox
{
    public class Rhythmbox : IPlugin
    {
        private string myName = "Rhythmbox";
        private string myDescription = "Rhythmbox plugin";
        private string myAuthor = "Anonymous";
        private string myVersion = "1.0.0";
        private string myEmail = ""; // optional

        IPluginHost myHost = null;
        ITools myTools = null;

        public string Description
        {
            get { return myDescription; }
        }

        public string Author
        {
            get { return myAuthor; }
        }

        public string Name
        {
            get { return myName; }
        }

        public string Version
        {
            get { return myVersion; }
        }

        public string Email
        {
            get { return myEmail; }
        }

        public IPluginHost Host
        {
            get { return myHost; }
            set { myHost = value; }
        }

        public ITools Tools
        {
            get { return myTools; }
            set { myTools = value; }
        }

        public void Initialize()
        {
            // This is called when the plugin is loaded
            // Suscribe to delegates here

            myHost.HookCommand(this, "/rb", "/rb", "Shows whats playing");
            myHost.OnCommand += new Command(myHost_OnCommand);
        }

        void myHost_OnCommand(object Window, string Command, string Args)
        {            
            if (Command.ToLower() == "/rb") 
            {
                if (exec("ps", "-C rhythmbox").IndexOf("rhythmbox") > -1)
                {
                    string song = exec("rhythmbox-client", "--print-playing-format %ta\\ -\\ %at\\ -\\ %tt\\ -\\ \"(%te/%td)\"");
                    SendRaw(Window, song);
                    
                }
                else
                {
                    myHost.NotifyUser("Your mediaplayer is not running");
                }
            }
        }

        string exec(String Cmd, String Args)
        {
            Process process = new Process();
            process.StartInfo = new ProcessStartInfo(Cmd, Args);
            process.StartInfo.UseShellExecute = false;
            process.StartInfo.RedirectStandardOutput = true;
            process.StartInfo.RedirectStandardError = true;
            process.StartInfo.RedirectStandardInput = true;
            process.Start();

            string data = process.StandardOutput.ReadToEnd();
            return data.Trim();
        }

        void SendRaw(Object Window, String Msg)
        {
            myHost.SendCommand(Window, "", Msg);
        }

        public void Dispose()
        {
            // This is called when the plugin is unloaded
        }
    }
}
